graficos = function (x, y, graphics = TRUE)

{
	if (class (x)!= "numeric"|length (x) != length(y))
	{
		stop ("no numrico ou vetores com \n tamanhos diferentes")
	}
	if (graphics==TRUE) 
	{
		x11()
		par ( mfrow=c(1,2), mar= c(4,4,2,2), bty="l",cex.lab=1.5, 
		cex =1.7, cex.main=1.8, las=1, tcl=0.3) 
		plot (x, y, cex=1.5, pch=16, col=c (rgb (0.3,1,0,0.5),
		rgb (1,0,0.3,0.5)))
		boxplot (x,y, col=c (rgb (0.3,1,0,0.5),rgb (1,0,0.3,0.5)) )
		
		
	}	

	x.s = summary (x)
	y.s = summary (y)
	xy.lm =lm (x~y)
	co.xy = coef (xy.lm)
	list.xy=list (x.s, y.s, co.xy)
	return (list.xy)
} 
x= abs(rnorm (10, 1,1))
y= abs(rnorm (10, 1,1))
graficos (x,y,graphics=T)