#criando grficos Editando alguns parmetros grficos
getwd()
setwd ("C:/Users/Pedro/Dropbox/Mestrado/Matrias/BIE Mestrado")
dir()
esaligna=read.table ("esaligna.txt", sep=",", header =T)
head (esaligna)
str (esaligna)
summary (esaligna)
esaligna$talhao=factor(esaligna$talhao)
dev.off ()
x11()
par (cex.lab=1.5, cex =1.7, las=1, cex.main=1.8, bty="l", tcl=0.3)
plot (esaligna$dap,esaligna$ht, pch=16, col=rgb(0.4,0,0), 
xlab="Dimetro  altura \n do peito (cm)", , ylab= "Altura (m)", 
main="Eucalypthus saligna")
savePlot ("saligna", type= "png")
#################################################################################### 
#Dois grficos juntos
par (cex.lab=1.5, cex =1.7, las=1, cex.main=1.8, bty="l",
 tcl=0.3, mfrow = c(1,2))
plot (esaligna [,3:4], xlab="Talhao", ylab= "Dimetro  altura \n do peito (cm)"
, main="Eucalypthus \n saligna", col=rgb(0.4,0,0))
text (locator (1), "a", cex=1.8)
media=tapply (esaligna$dap, list(esaligna$talhao), mean)
desvio.p=tapply (esaligna$dap, list(esaligna$talhao), sd)
plot (media, pch=16, col=rgb(0.4,0,0),main="Eucalypthus \n saligna", 
xlab="Talhao", ylim=c(5,30))
segments(x0=c(1:6), y0=media-desvio.p, y1=media+desvio.p) 
text (locator (1), "b", cex=1.8)
savePlot ("saligna2", type= "png")
####################################################################################
#Adivinhando o cdigo
adivinha=read.table("Adivinha.txt", sep=",", header =T)
par (cex.lab=1.5, cex =1.7, cex.main=1.8, bty="l",
 tcl=0.3, mfrow = c(1,2), family= "serif")
adivinha.1=plot (adivinha$x1,adivinha$y1, pch= 17, ylim=c(0,3), 
xlab="Log(Pathcsize)(ha)",ylab= "Euclidian distances")
adivinha$x1->x.1
adivinha$y1->y.1
model=lm(x.1~y.1)
abline(model, lwd=2)
text (locator (1), "a", cex=1.8)
par(xaxt="n")
adivinha$y2=factor (adivinha$y2)
plot (adivinha [,4:3],pch=8, ylim=c(0.0, 3.5), ylab=NULL,
 xlab=NULL)
mtext(c("Small", "Medium \n Edge","Medium \n Interior", "Large \n Edge", 
"Large \n Interior","Control"),side= 1,cex=1,line=1.5,at=c(1,2,3,4,5,6))
text (locator (1), "b", cex=1.8)

rm(list=ls())
dev.off()
