#Patrcia Coutinho Mller
#Exerccios 7b
#1
bebes <- read.table("babies.txt", header= TRUE, as.is = TRUE, sep= " ")
str(bebes)
summary(bebes)

#remoo de dados faltantes

bebes<-bebes[bebes$bwt != "999",]
bebes<-bebes[bebes$gestation != "999",]
bebes<-bebes[bebes$parity != "9",]
bebes<-bebes[bebes$age != "99",]
bebes<-bebes[bebes$height != "99",]
bebes<-bebes[bebes$weight != "999",]
bebes<-bebes[bebes$smoke != "9",]

#transformao oz->kg

bebes$bwt<-bebes$bwt*0.0283495
bebes$bwt
summary(bebes)

par(mfrow=c(1,1))
plot(bwt~gestation, data=bebes)

#vetor para representar a varivel preditora

x<- seq(min(bebes$gestation), max(bebes$gestation), len=100)##Calculando a variancia dos valores de y observados.
var.y <- var(bebes$bwt)
var.y


#soma desvios q

media.gestation<-mean(bebes$gestation)

ssx<- sum((bebes$gestation-media.gestation)^2)

ssx 

#varincia 
ss <- var(bebes$bwt)
ss

#nmero de observaes
n<-length(bebes$bwt)
n
## erro padrao da previsao do modelo

x1<-(x-media.gestation)^2


erro <- sqrt(ss*((1/n) + (x1/ssx)))
erro

model<-lm(bebes$bwt~bebes$gestation)
summary(model)

#valor de t para n-2 graus de liberdade

t<-qt(0.025,1172, lower.tail=F)


#intervalos de confiana

int1<- erro*(t)

int2<- erro*(-t)

coef.lm <- coef(model)

#upper e lower limit, y=b + ax

y.u= coef.lm[1] + (coef.lm[2]*x)+int1

y.l= coef.lm[1] + (coef.lm[2]*x)+int2

plot(bebes$bwt~bebes$gestation, xlab="Tempo de Gestao (dias)", ylab="Peso do beb (kg)")

polygon(c(rev(x),x),c(rev(y.u),y.l), col=rgb(1,0,0,0.3))
abline(model)

#2

init.h = c(600, 700, 800, 950, 1100, 1300, 1500)
h.d = c(253, 337, 395, 451, 495, 534, 573)

plot(h.d~init.h)

mod1 <- lm(h.d~init.h)

mod2 <- update(mod1,.~. +I(init.h^2))

anova(mod1,mod2)

abline(mod1)
cf.m2 <- coef(mod2)
curve(cf.m2[1]+cf.m2[2]*x+cf.m2[3]*x^2, add=T, lty=2, col="red")

summary(mod2)

mod3<-update(mod2,.~.+I(init.h^3))

anova(mod1,mod2,mod3)

cf.m3 <- coef(mod3)
curve(cf.m3[1]+cf.m3[2]*x+cf.m3[3]*x^2+cf.m3[4]*x^3, add=T, lty=1, col="blue")

#O polinmio de terceiro grau  o melhor modelo para descrever os dados do experimento de Galileu. Os resduos de mod1, mod2 e mod3 indicam
#que o polinmio de terceiro grau explica mais a variao dos dados que os outros.

#3

bebes <- read.table("babies.txt", header= TRUE, as.is = TRUE, sep= " ")
str(bebes)
summary(bebes)

#remoo de dados faltantes

bebes<-bebes[bebes$bwt != "999",]
bebes<-bebes[bebes$gestation != "999",]
bebes<-bebes[bebes$parity != "9",]
bebes<-bebes[bebes$age != "99",]
bebes<-bebes[bebes$height != "99",]
bebes<-bebes[bebes$weight != "999",]
bebes<-bebes[bebes$smoke != "9",]

#transformar parity e smoke em fator

bebes$parity<- as.factor(bebes$parity)
bebes$smoke<-as.factor(bebes$smoke)

#modelo cheio

bebes.full<-lm(bwt~gestation*parity*age*height*weight*smoke, data=bebes)

anova(bebes.full)

# possvel observar que nenhuma das interaes entre trs, quatro, cinco e seis fatores foi significativa (p<0.05)
#na anlise do modelo cheio

#seguirei com as interaes duplas 

bebes.1<- lm(bwt~gestation*age+ gestation*weight+ gestation*smoke+gestation*height+gestation*parity+
               parity*height+parity*age+parity*weight+parity*smoke+ age*weight+age*height+
               age*smoke+ weight*height+weight*smoke+height*smoke, data=bebes)
anova(bebes.1)
anova(bebes.full,bebes.1) #reter o mais simples (bebes.1) e seguir simplificando


#sem height*Smoke

bebes.2<- lm(bwt~gestation*age+ gestation*weight+ gestation*smoke+gestation*height+gestation*parity+
               parity*height+parity*age+parity*weight+parity*smoke+ age*weight+age*height+
               age*smoke+ weight*height+weight*smoke, data=bebes)


anova(bebes.1, bebes.2) #reter o mais simples (bebes.2) e seguir simplificando

#sem weight*smoke

bebes.3<- lm(bwt~gestation*age+ gestation*weight+ gestation*smoke+gestation*height+gestation*parity+
               parity*height+parity*age+parity*weight+parity*smoke+ age*weight+age*height+
               age*smoke+ weight*height, data=bebes)

anova(bebes.2, bebes.3) #reter o mais simples (bebes.3) e seguir simplificando

#sem weight*height

bebes.4<- lm(bwt~gestation*age+ gestation*weight+ gestation*smoke+gestation*height+gestation*parity+
               parity*height+parity*age+parity*weight+parity*smoke+ age*weight+age*height+
               age*smoke, data=bebes)

anova(bebes.3,bebes.4) #reter o mais simples (bebes.4) e seguir simplificando

#sem age*smoke

bebes.5<- lm(bwt~gestation*age+ gestation*weight+ gestation*smoke+gestation*height+gestation*parity+
               parity*height+parity*age+parity*weight+parity*smoke+ age*weight+age*height, data=bebes)

anova(bebes.4, bebes.5) #reter o mais simples (bebes.5) e seguir simplificando

#sem age*height

bebes.6<-lm(bwt~gestation*age+ gestation*weight+ gestation*smoke+gestation*height+gestation*parity+
              parity*height+parity*age+parity*weight+parity*smoke+ age*weight, data=bebes)

anova(bebes.5,bebes.6) #reter o mais simples (bebes.6)e seguir simplificando

#sem age*weight

bebes.7<-lm(bwt~gestation*age+ gestation*weight+ gestation*smoke+gestation*height+gestation*parity+
              parity*height+parity*age+parity*weight+parity*smoke, data=bebes)

anova(bebes.6, bebes.7) #reter o mais simples (bebes.7)e seguir simplificando
anova(bebes.7)

# sem parity*smoke 

bebes.8<-lm(bwt~gestation*age+ gestation*weight+ gestation*smoke+gestation*height+gestation*parity+
              parity*height+parity*age+parity*weight, data=bebes)

anova(bebes.7, bebes.8) #reter o mais simples (bebes.8)e seguir simplificando

anova(bebes.8) 

#sem parity*weight

bebes.9<-lm(bwt~gestation*age+ gestation*weight+ gestation*smoke+gestation*height+gestation*parity+
              parity*height+parity*age, data=bebes)

anova(bebes.8, bebes.9) #reter o mais simples (bebes.9)e seguir simplificando

#sem parity*age

bebes.10<-lm(bwt~gestation*age+ gestation*weight+ gestation*smoke+gestation*height+gestation*parity+
               parity*height, data=bebes)

anova(bebes.9, bebes.10) #reter o mais simples (bebes.10) e seguir simplificando

#sem parity*height

bebes.11<-lm(bwt~gestation*age+ gestation*weight+ gestation*smoke+gestation*height+gestation*parity, data=bebes)

anova(bebes.10, bebes.11) #reter o mais simples (bebes.11)e seguir simplificando
anova(bebes.11)

#sem gestation:parity

bebes.12<-lm(bwt~gestation+ age + weight+ smoke +height +parity+ gestation:age+gestation:weight
             +gestation:smoke+gestation:height, data=bebes)
anova(bebes.12)
anova(bebes.11, bebes.12)#reter o mais simples (bebes.12)e seguir simplificando

#sem gestation:height

bebes.13<-lm(bwt~gestation+ age + weight+ smoke +height +parity+ gestation:age+gestation:weight
             +gestation:smoke, data=bebes)
anova(bebes.13)
anova(bebes.12, bebes.13) #reter o mais simples (bebes.13)e seguir simplificando

#sem gestation:weight

bebes.14<-lm(bwt~gestation+ age + weight+ smoke +height +parity+ gestation:age+gestation:smoke, data=bebes)
anova(bebes.14)
anova(bebes.13, bebes.14) #reter o mais simples (bebes.14)e seguir simplificando

#sem age (nica varivel com p valor no significativo)

bebes.15<-lm(bwt~gestation+ weight+ smoke +height +parity+ gestation:age+gestation:smoke, data=bebes)
anova(bebes.15)
anova(bebes.14, bebes.15) #reter o mais complexo(bebes.14)!!

par(mfrow=c(2,2))
plot(bebes.14)

#modelo mnimo adequado: bebes.14

#O melhor modelo de previso da massa de bebs ao nascer  lm(bwt~gestation+ age + weight+ smoke +height +parity+ gestation:age+gestation:smoke, data=bebes)











