# 9.2 Exerccio Anlise exploratria simultnea de duas variveis
# Tarefa: Crie uma funo para sada grfica de anlises exploratrias de duas variveis. Essa sada pode
# ter por exemplo boxplot, histograma, qq norm e y por x. A funo deve permitir a entrada de dois objetos 
# vetores de mesmo tamanho (x e y). Caso os valores de x e y forem desenhados em um mesmo grfico, defina cores 
# diferentes. As legendas devem ser em portugus e a sada (return) deve apresentar o sumrio das duas variveis
# e o coeficiente de correlao.

# DICAS:

# Para histogramas com variveis em um mesmo grfico pode ser utilizada a funo multhist() do pacote plotrix.
# Baixe, instale o pacote e veja o help da funo.
# Utilize o cdigo do eda.shape, apresentado em aula como ponto de partida.
# Lembre-se que em algumas funes grficas o argumento add=TRUE, adiciona elementos no grfico anterior.

x <- as.numeric(sample(1:30,10))
y <- as.numeric(sample(1:50,10))

explore.an <- function (x,y,main="bla bla",xlab="ble",ylab="blu",xlim=range(x),ylim=range(y))	{

	if(class(x)!="numeric"|class(y)!="numeric")	{ 
	   cat("\t","HEEEEY! Vetor no numrico","\t")
	}
	if(length(x)!=length(y))	{
	   cat("\t","HEEEEY! Vetores de tamanhos diferentes","\t")
	}
	plot(x,y, main=main,xlab=xlab,ylab=ylab,col=c("purple","green"),pch=19)
	summa1 <- summary(x)
	summa2 <- summary(y)
	coef.cor <- cor(x,y)
	res <- list(c(summa1,summa2,coef.cor))
	return (res)

	}

explore.an(x,y)


# testando
temp <- as.numeric(sample(20:38,10))
chu <- as.numeric(sample(500:1500,12)) # com tamanho diferentes ( para mostrar o erro)

explore.an (temp,chu,main="Temperatura x Chuva",xlab="Temperatura",ylab="Chuva",xlim=range(temp),
	ylim=range(chu)) 

# teste 2
x1 <- sample(35:70,10)
y1 <- sample(60:95,10)

explore.an (x1,y1,main="x1 e y2",xlab="yyy",ylab="xxx",xlim=range(x1),
	ylim=range(y2))

