#Exercicios 8. Reamostragem e Simulacao#

#Exercicio 1#

eutad <- read.table("palmadulto.txt", header=TRUE)
eutad
str(eutad)
dist <- matrix(NA, nrow=102, ncol=102)
dist

for (i in 1:101) 
     {
	for (j in (i+1):102) 
             {
		difx2 = (eutad$gx[i] - eutad$gx[j]) ^ 2
                dify2 = (eutad$gy[i] - eutad$gy[j]) ^ 2
                dist[i,j] = sqrt(difx2 + dify2)
                dist[j,i] = sqrt(difx2 + dify2)
             }
     }

nn  <- apply(dist, 1, min, na.rm=TRUE)
nn
mnn <- mean(nn)
mnn

resultado <- rep(NA, 1000)
resultado[1] <- mnn
mnn

for (k in 2:1000) 
     {
	xsim <- runif(102,0,302)
	ysim <- runif(102,0,302)

	matrizxy <- matrix(NA, ncol=102, nrow=102)

	for (l in 1:101) 
             {
		for (m in (l+1):102) 
                     {
	                matrizxy[l,m] = sqrt( ((xsim[l] - xsim[m]) ^ 2) + ((ysim[l] - ysim[m]) ^ 2) )
	                matrizxy[m,l] = sqrt( ((xsim[l] - xsim[m]) ^ 2) + ((ysim[l] - ysim[m]) ^ 2) )
	             }
	     }

	resultado[k] = mean(apply(matrizxy, 1, min, na.rm=TRUE))
     }

hist(resultado)
abline(v=resultado[1], col="red", lty=2)

prob <- (sum(abs(resultado) >= abs(resultado[1])))/length(resultado)
prob

# Exercicio 2#

massa <- read.table("animais.txt", sep=";", header=TRUE, dec=",")
massa <- na.omit(massa)
massa
massa.mod <- lm(log(brain)~log(body), data=massa)
massa.mod
body <- massa$body
body
vetor <- rep(NA, 1000)
vetor[1] <- massa.mod$coefficients[2]

for (i in 2:1000) 
     {
	     sim_brain = sample(massa$brain)
	     vetor[i] = (lm(log(sim_brain) ~ log(body)))$coefficients[2]
      }
hist(vetor)
abline(v=vetor[1], col="red")
prob <- sum(vetor>=vetor[1])
prob
p.prob <- prob/1000
p.prob