#########Exerccios 8. Reamostragem e Simulao #############

#Exerccio 1.

#Os palmitos esto distribudos aleatoriamente na floresta? Durante a aula terica mostramos como podemos usar uma distribuio terica para gerar dados que simulem o cenrio previsto por nossa hiptese nula. No caso da posio dos palmitos adultos em uma parcela de 10,24 ha de floresta (320320 m), nossa hiptese nula  que eles se distribuem aleatoriamente no espao. Iniciamos a construo do cdigo para testar essa hiptese, o exerccio  terminar de testar a hiptese. Abaixo reproduzimos o cdigo apresentado em aula para que possa continuar a partir dele.

#1.1. Baixe o arquivo palmadulto.txt e leia os dados no R em um objeto chamado eutad, no esquea de conferir se o objeto de dados foi lido corretamente.
#1.2. Crie o objeto para guardar as distncias entre cada indivduo:


setwd("C:/Curso R/Curso R 2019/Aula 8")
eutad <- read.table("palmadulto.txt", header = T, sep="\t", as.is = T)

eutad[1:6,]



#1.3. Calcule a distncia observada entre cada indivduo e guarde o resultados em dist:

# cria uma matriz de 102 x 102
dist=matrix(NA, ncol=102, nrow=102)

for(i in 1:101)
{
  for(j in (i+1):102)
  {
    difx2=(eutad$gx[i]-eutad$gx[j])^2
    dify2=(eutad$gy[i]-eutad$gy[j])^2
    dist[i,j]<-sqrt(difx2 + dify2)
    dist[j,i]<-sqrt(difx2 + dify2)
  }
  
}

# exibe parte da matrix
dist[1:6,1:6]

# (a=(5.7-2.9)^2 + (28 - 237)^2 >>>> sqrt(a)) >>>> na matriz "dist" [1,] [,2], onde i=linha, j= coluna -"j in i+1" ir colocar o valor obtido entre as coordeandas xy na linha 1 coluna 2, e assim por diante.


#1.4. Verifique o objeto dist e calcule o parmetro chamado de distncia mdia do vizinho mais prximo (MNN):

(nn<-apply(dist, 1, min, na.rm=TRUE))
(mnn<-mean(nn))

#Simulando
#At agora calculamos o valor esperado da distncia mdia do vizinho mais prximo. Os prximos passos, so 1):

#1.5. Crie um vetor resultado, com 1000 NA's, para guardar os valores de cada simulao.
#1.6. Guarde o valor observado na primeira posio de resultado;
#1.7. Crie um ciclo com contador (k) que vai de 2 a 1000;
# 1.8. Dentro do ciclo:
#1.8.1. Crie o objetos xsim, um vetor com valores amostrados aleatoriamente de uma distribuio uniforme de 0 a 320 (o tamanho x da parcela), arredondando o valor para uma casa decimal2). Lembre-se de sortear o mesmo quantidade de valores que a populao de palmito observado;
#1.8.2. Faa o mesmo que no passo anterior e guarde no objeto ysim;
#1.8.3. Como no tpico anterior, crie uma matriz para guardar as distncias entre cada valor xy simulados;
#1.8.3. Crie os ciclos para o calculo das distncias como no tpico anterior;
#1.8.4. Guarde o valor da distncia mdia do vizinho mais prximo dos dados simulados na posio k do vetor resultado;
#1.8.5. Feche o ciclo.

resultado <- rep(NA, 1000)
resultado[1]<- mnn
for(k in 2:1000)
{
  
      xsim<- sample(round(runif(320,0,320),1), 102)
      ysim<-sample(round(runif(320,0,320),1),102)
      xy<- data.frame(xsim, ysim)
      media.dist<- as.matrix(dist(xy, diag=F, upper=T))
      diag(media.dist)<-NA
      sim.dist<- apply(media.dist, 1, min, na.rm=TRUE)
      resultado[k] <- mean(sim.dist, na.rm = TRUE)
      
  }
  
  



#1.9. Faa um histograma dos valores simulados e coloque uma linha vermelha vertical na posio do valor observado;

hist(resultado)

abline(v = resultado[1], col="red")

#1.10. Calcule a probabilidade de uma distribuio espacial aleatria gerar valores iguais ou mais extremos do que o valor MNN observado.


probab <- sum(resultado>=resultado[1])
probab


p.valor=probab/length(resultado)
p.valor

### probabilidade de 97,2%


# Exerccio 2
#Simulando o teste de uma regresso linear
#O principal teste estatstico de uma regresso linear  que a inclinao do modelo da reta  diferente de zero! Isso significa que a varivel preditora  independente da varivel reposta. Ou seja no h relao aparente entre elas. Utilizando os dados de massa corprea e do crebro de alguns vertebrados Conjunto de Dados: Massa do Corpo e do Crebro de Vertebrados:

#2.1. Calcule a inclinao da relao log(brain) ~ log(body) 3);



animais<-read.table("animais.txt", header = T, sep =";", as.is = T)
str(animais)
animais$body<- as.numeric(animais$body)
animais$brain<- as.numeric(animais$brain)
animais

animais[animais ==""] <-NA
animais<-na.omit(animais)
animais


massa <-log(animais$body)
massa
cerebro<-log(animais$brain)
cerebro
m.massa<- mean(massa)
m.cerebro<- mean(cerebro)
beta= sum((massa - m.massa) * (cerebro- m.cerebro))/ sum((massa - m.massa)^2)
beta



#2.2. Crie um vetor para guardar o resultado de simulaes;



resultado <- rep(NA, 1000)

##2.3. Guarde o valor observado no objeto criado em 2.2;

resultado[1]<- b

#2.4. Abra um ciclo de 2 a 1000;
#2.5. Desordene o vetor brain e guarde no objeto sim_brain;
#2.6. Calcule a inclinao entre o log(sim_brain) ~ log(body) e guarde no vetor resultado;
#2.7. Feche o ciclo;

for (i in 2:1000)
{
    sim_brain<- sample(cerebro, length(cerebro))
    resultado[i]<-coef(lm(sim_brain ~ massa))[[2]] 
  
}

resultado

#2.8. Faa o histograma dos valores simulados e compare com o valor observado da inclinao da relao;

hist(resultado)
abline(v = resultado[1], col="red")

bicaudal=sum(resultado>=resultado[1]| resultado<=(resultado[1]*-1))
bicaudal

#2.9. Calcule a probabilidade da inclinao observada ter sido gerada por variveis que so independentes;

p.bi=bicaudal/length(resultado)
p.bi


