#Exerccios 9 - Construo de Funes
#9.1 Exerccio Funes simples

conversor<- function(x)
{ 
  F<-x
  resultado<-((F-32)*(5/9))
  return(as.matrix(resultado))
}


#9.2 Exerccio Anlise exploratria simultnea de duas variveis

#Tarefa: Crie uma funo para sada grfica de anlises exploratrias de duas variveis. Essa sada pode ter por exemplo boxplot, histograma, qq norm e y por x. A funo deve permitir a entrada de dois objetos vetores de mesmo tamanho (x e y). Caso os valores de x e y forem desenhados em um mesmo grfico, defina cores diferentes. As legendas devem ser em portugus e a sada (return) deve apresentar o sumrio das duas variveis e o coeficiente de correlao.

a=sample(runif(1000,100,1000), 50)
b=sample(runif(1000,100,1000), 50)





Explor<- function(x0, y0, graphic= T, mypar= c(mar=c(4,4,2,2)), xlim=(x0), ylim= range(y0))
  
{
  
  par(mfrow=c(3,2), mar=c(4,6,5,2))
  
  if(length(x0) != length(y0))
  {stop("objetos no possuem o mesmo comprimento")}
  
  {
    
    dados<- data.frame(x0,y0)
    boxplot(dados, col = c("yellow", "purple"), ylab="Valores aleatrios \n de uma dist. uniforme")
    correl<-lm(dados$y0~dados$x0)
  }
  {
    
    multhist(list(a,b), beside = T, freq = FALSE, probability = !freq, plot.it = T, col=c("pink", "blue"), ylab="Valores aleatrios \n de uma dist. uniforme")
    
  }
  {
    plot(dados$y0~dados$x0, main="varivel X",  xlab="varivel X", ylab="varivel Y")
    abline(correl, col="red")
  }
  
  
  qqnorm(residuals(correl), ylab= "Residuals")
  
  
  
  return (list(summary(dados),coef(correl)))
  
  
}

Explor(a,b)



#109.3 ndice de diversidade de espcies
#Construa uma funo chamada "shannon" para computar o ndice de diversidade de Shannon e outra funo chamada "simpson" para o ndice de diversidade de Simpson de uma amostra. Considere que:
#o objeto de entrada ser um vetor contendo a abundncia de cada espcie na amostra
#existe a possibilidade de haver dados faltantes nesse vetor ("NA"), os quais sero removidos para o clculo dos ndices.


shannon<-function(x)

  {
 x<- na.omit(x)
  
 indice.shanon <- rep(NA, length(x))
  for (i in 1:30)
   
   {
   
    indice.shanon[i]<-  - sum((x/sum(x))* (log(x/sum(x))), na.rm = T)
    }
    
    return(indice.shanon)
  
  }

shannon(abund)


simpson<- function(x)
  
{ 
  x<- na.omit(x)
  indice.simpson <- rep(NA, length(x)) 
  for (i in 1:30)
  {
      indice.simpson[i]<- sum((x/sum(x))^2, na.rm = T) 
      }
  
  return(indice.simpson)
 }

simpson(abund)


#Agora considere que voc coletou varias amostras de abundncia das espcies em diversas comunidades e organizou esses dados em uma matriz, na qual as linhas representam espcies e as colunas representam diferentes amostras. Construa uma funo chamada " diversidade", que retorna um vetor contendo um dos dois ndices de diversidade (a ser escolhido pelo usurio), calculado para cada amostra.
#Lembre-se que:
  
#Esta funo dever possuir dois argumentos: o primeiro deve representar os dados, e o segundo deve ser um parmetro relacionado  escolha do usurio (e.g. indice), que poder receber os valores "shannon" ou "simpson".
#O objeto de entrada na funo "diversidade" dever ser uma matriz com a abundncia das espcies nas linhas e amostras nas colunas.
#Valores faltantes ("NA") nessa matriz devero ser removidos para o clculo dos ndices.
#BNUS! Seria bacana se a funo diversidade acusasse erro caso o usurio escolha um ndice diferente dos esperados. Tambm seria bacana se o usurio pudesse usar apenas as primeiras letras para indicar o ndice: "sh" para Shannon e "si" para Simpson. A funo match.arg pode ser usada para fazer essas duas coisas! Descubra como...


diversidade<- function(x, indice = c("sh", "si"))
    {
    
    x<- data.frame(x)
    x<- na.omit(x)
    indice<- match.arg(indice) 
    if(indice != "sh"| indice != "si")   
    
    { stop("indice diferente do esperado")}
    
    if(indice == "sh" )
    indice.shanon<- rep(NA, length(nrow(x)))
    for(i in 1:nrow(x))
    {
      abund<- apply(x, 2, sum)
      N<- sum(x)
      indice.shanon[i]<- -sum((abund/N) * (log(abund/N)), na.rm = T)
    }

if (indice == "si")
{ stop("indices diferente do esperado")}
  indice.simpson<- rep(NA, length(nrow(x)))
for(i in 1:nrow(x))
{
  indice.simpson[i] <- sum(((abund/N)^2), na.rm = T) 
}

return(list(indice.shanon, indice.simpson))
}

diversidade(ab,"sh")
diversidade(ab, indice= "si")


a<- round(sample(runif(100, 1, 100), 20))
b<- round(sample(runif(100, 1, 100), 20))

ab <-data.frame(a,b)


