#7.2 O modelo mais simples possvel

# Vamos retomar a regresso da massa do crebro em funo da massa corporal de alguns animais, do tutorial ajuste e diagnstico de uma regresso:

library(MASS) #chamando o pacote

data(Animals) #chamando o banco de dados

str(Animals) #verificando a estrutura

anim.m2 <- lm(log(brain) ~ log(body), data =Animals, 
              subset =!(log(Animals$body) > 8 & log(Animals$brain) < 6))

summary(anim.m2) #resumo do modelo

# Agora ajuste este modelo:

anim.m0 <- lm(log(brain) ~ 1, data = Animals, 
              subset =!(log(Animals$body) > 8 & log(Animals$brain) < 6))

summary(anim.m0) #resumo do modelo

# E compare os dois:

anova(anim.m0, anim.m2)

#Perguntas
#1. Qual a relao do comando 'anova' acima com:

anova(anim.m2)

# A funo 'anova" apresenta a 'Tabela de anlise de varincia' e realiza o teste de um modelo em relao a outro, em uma sequncia j definida. A relao entre estes dois comandos  que ambos levam  mesma concluo, uma vez que fazem uma comparao com o modelo nulo e idicam o mesmo valor de estimativa "f" e do valor de p.  

#2. Qual a relao entre os valores obtidos por estes comandos

summary(anim.m0) 

mean(log(Animals$brain[ !(log(Animals$body) > 8 & log(Animals$brain) < 6)]))

sd(log(Animals$brain[ !(log(Animals$body) > 8 & log(Animals$brain) < 6)]))

# O segundo e terceiro comando esto relacionados com o primeiro, de tal forma que este primeiro mostra o resumo do modelo, contendo informaes dos resduos, dos coeficientes e do erro padro residual. Assim, o segundo apresenta o mesmo valor que consta na estimativa do intercepto do primeiro comando e o terceiro mostra o mesmo valor do erro padro residual que tambm consta no primeiro comando, "summary". 


#Dica
#Um comando mais curto para ajustar o modelo deste exerccio, e que ajuda a interpret-lo:

anim.m0 <- update(anim.m2, .~. -log(body))
