# Wiki_3_Exercicios_5_Graficos

#Exercício 5.1

saligna <- read.table("esaligna.csv", header = T, sep = ",")
saligna
?par
?hist
# pch=19 é a bolinha cheia
x.lab.saligna <- "Diâmetro à altura do peito (cm)"
y.lab.saligna <- "Altura (m)"
main.saligna <- "*Eucalypthus saligna*"
png("saligna.png")
par(pch=19, cex=1.4, cex.axis=1.5, cex.lab=1.7, col=rgb(1,0,0), tcl=0.3, las=1, bty="l", cex.main=1.8, mar=c(5,4,4,2)+0.1, mgp=c(2.5,0.25,0)) #margem (mar=) e distancias da legenda, eixo e linha (mgp=) não fazem parte do exercício, mas preferi ajustar
plot(saligna$ht~saligna$dap, main=main.saligna, xlab=x.lab.saligna, ylab=y.lab.saligna)
dev.off()
# OBS do Edu em aula: No exercício 5.2, usem o tamanho de letra que permita caber na janela, não precisa manter necessariamente o padrão de formatação do exercício anterior como solicitado no 5.2

###Exercício 5.2

## 5.2.2 Formatação:
par(pch=19, cex=1.1, cex.axis=0.8, cex.lab=1.3, col=rgb(1,0,0), tcl=0.3, las=1, bty="l", cex.main=1.5, mar=c(5,4,4,2)+0.1, mgp=c(2.5,0.25,0)) 

## 5.2.1 Gerando dois gráficos:

# Graf.1

?boxplot
?plot
par(mfrow=c(1,2))
boxplot(saligna$dap~saligna$talhao, xlab="talhao", ylab=x.lab.saligna, main= "Boxplot E.Saligna",xaxt="n")
as.factor(saligna$talhao) # Levels=16 17 18 22 23 32
axis(side = 1,at=c(1,2,3,4,5,6), labels = c(16, 17, 18, 22, 23, 32))
text(1,22, "a", cex=1.5, col=rgb(0,0,1)) ## (5.2.3. letra do grafico)

# Graf.2

# preparar

head(saligna)
str(saligna)
saligna$talhao <- factor(saligna$talhao) # pois o as.factor só lê como fator, não converte
class(saligna$talhao) # está "factor"
media.talhao <- as.vector(tapply(saligna$dap,saligna$talhao,mean))
class(media.talhao) # (está "numeric")
media.talhao #(seis valores de médias de cada talhão)
desv.pad.talhao <- as.vector(tapply(saligna$dap,saligna$talhao,sd))
class(desv.pad.talhao) # está "numeric"
desv.pad.talhao #(seis valores de sd de cada talhão)

# plotar
#medias
plot(media.talhao~c(16, 17, 18, 22, 23, 32),xlab="talhao", ylab="Media e desvio padrao do DAP (cm)", xaxt="n", ylim=c(8,18))
#eixo
axis(side = 1,at=c(1,2,3,4,5,6), labels = c(16, 17, 18, 22, 23, 32))

text(1,22, "b", cex=1.5, col=rgb(0,0,1)) ## 5.2.3. letra do grafico