#Exerccio 5.1#

#Editando alguns parmetros grficos
saligna <- read.csv("esaligna.csv", header=T, sep=",")
saligna
str(saligna)
plot(x = saligna$dap, y = saligna$ht, cex = 1.4, pch=19, col ='red', xlab = "Dimetro  altura do peito (cm)", ylab = "Altura (m)", cex.lab = 1.5, cex.axis = 1.7, tcl = 0.3, las = 1, bty = "l", main = "Eucalypthus saligna", cex.main = 1.8)
png(filename = "saligna.png")
graphics.off()

#Exerccio 5.2#

media <- tapply(saligna$dap, saligna$talhao,FUN=mean)
media
desvpadrao <- tapply(saligna$dap,saligna$talhao,FUN=sd)
desvpadrao
par(mfrow=c(1,2), las=1, tck=0.03, bty="l")
boxplot(saligna$dap~saligna$talhao,main="Eucalypthus saligna",cex.main=1.6,cex.axis=1.3,xlab="Talho",ylab="DAP",cex.lab=1.5)
text(x=0.8,y=23,labels="A")
plot(mean.saligna,ylim=c(0,30),pch=16, col="red", cex=1.4, xaxt="n", main="Eucalypthus saligna", cex.main=1.6,cex.axis=1.3,xlab="Talho", ylab="Mdia DAP",cex.lab=1.5)
segments(c(1,2,3,4,5,6),c(6,7,8,10,9,7),c(1,2,3,4,5,6),c(14,19,16,20,19,19))
text(x=1.5,y=30,labels="B")
axis(side=1, at=c(1,2,3,4,5,6), c(16,17,18,22,23,32)) 

#Exerccio 5.3#

exercicio <- read.table("exercicio3.csv",header = T,sep = ",",dec = ".",as.is = T)
par(mfrow=c(1,2),bty="l", tcl=0.4)
plot(y1~x1,data = exercicio, pch=17, ylab="Euclidean distances", xlab="Log(Patch size)(ha)",cex.lab=1.3, ylim=c(0,3), xlim =c(0.5, 2.5) )
abline(lm(y1~x1,data = exercicio),lwd=2)
mtext("a", side=3, line=0, at=2.5,cex=1.5, family="serif")
boxplot(exercicio$x2 ~ exercicio$y2, xlab = "", ylab = "", xaxt = "n")
axis(side = 1,at=1:6,labels = c("Small","Medium\n Edge","Medium\nInterior", "Large\nEdge","Large\nInterior","Control"),cex.axis=0.8)
mtext("*", side=3, line=0, at=c(1,2,4),cex=1.3, family="serif")
mtext("**", side=3, line=0, at=3,cex=1.3, family="serif")
mtext("***", side=3, line=0, at=5,cex=1.3, family="serif")
mtext("b", side=3, line=0, at=6.5,cex=1.5, family="serif")
