########## 106.2 ANOVA na unha ###########

mudas<- read.table("altura-mudas.csv", header = T, sep=",", as.is=T)
str(mudas)

# 1. Qual  a varivel medida e qual  o fator de interesse? Quantas rplicas existem para cada dado? 
#Faa grficos mostrando os dados e os desvios relacionados s amostras e aos substratos (variao total, intra-grupos e entre-grupos). 

## 1.1.R. A varivel medida  a altura da mudas em funo do substrato. 



###1.2.R. Existem 6 replicas para cada dado.
#1. Verifique a estrutura dos seus dados. Qual  a varivel medida e qual  o fator de interesse? Quantas rplicas existem para cada dado? 
#Faa grficos mostrando os dados e os desvios relacionados s amostras e aos substratos (variao total, intra-grupos e entre-grupos).



#####3 boxplot para para as duas espcie 


boxplot(mudas$altura~mudas$substrato, xlab="Tipos de substrato", ylab= "Altura")
table(mudas$altura, mudas$substrato)
hist(mudas$altura, xlab= "Altura")

table(mudas$altura, mudas$substrato)
barplot(table(mudas$altura, mudas$substrato))

### frequencia por espcie 

altura.painera<- mudas[mudas$especie=="paineira",]$altura
hist(altura.painera, xlab= "Altura das mudas", main="Paineira")
curve(expr = dnorm(x,mean=mean(altura.painera),sd=sd(altura.painera)),add=T, col="red")

plot(density(altura.painera),col="blue", ylim=c(0,0.08))
curve(expr = dnorm(x,mean=mean(altura.painera),sd=sd(altura.painera)),add=T, col="red")

hist(mudas[mudas$especie=="tamboril",]$altura, xlab= "Altura das mudas", main="Tamboril")
curve(expr = dnorm(x,mean=mean(mudas[mudas$especie=="tamboril",]$altura),sd=sd(mudas[mudas$especie=="tamboril",]$altura)),add=T, col="red")
abline(v=mean(mudas[mudas$especie=="tamboril",]$altura), col="red")


### y= variavel resposta, x=variavel preditora
boxplot(altura~substrato, data=tamboril)

#### indexaco por especie
tamboril<- mudas[mudas$especie == "tamboril",]

tamboril$substrato<- as.factor(tamboril$substrato)
boxplot(tamboril$altura~ tamboril$substrato)

tamboril$substrato

boxplot(tamboril$altura ~ tamboril$substrato, xlab= "Tipos de substrato", ylab="Altura")


tamboril.altura<- tamboril$altura


plot(1:60,tamboril.altura, pch=rep(c(15:24),each=6),col=rep(1:10,each=6), xlim=c(0,60))
for(i in 1:6)
{
  lines(c(i,i),c(tamboril.altura[i],medias[medias$Group.2 == 1,][3]),col=1)
}
for(j in 7:12)
{
  lines(c(j,j),c(tamboril.altura[j],medias[medias$Group.2 == 2,][3]),col=2)
}
for(k in 13:18)
{
  lines(c(k,k),c(tamboril.altura[k],medias[medias$Group.2 == 3,][3]),col=3)
}
for(l in 19:24)
{
  lines(c(l,l),c(tamboril.altura[l],medias[medias$Group.2 == 4,][3]),col=4)
}
for(m in 25:30)
{
  lines(c(m,m),c(tamboril.altura[m],medias[medias$Group.2 == 5,][3]),col=5)
}
for(n in 31:36)
{
  lines(c(n,n),c(tamboril.altura[n],medias[medias$Group.2 == 6,][3]),col=6)
}

for(o in 37:42)
{
  lines(c(o,o),c(tamboril.altura[o],medias[medias$Group.2 == 7,][3]),col=7)
}
for(p in 43:48)
{
  lines(c(p,p),c(tamboril.altura[p],medias[medias$Group.2 == 8,][3]),col=8)
}
for(q in 49:54)
{
  lines(c(q,q),c(tamboril.altura[q],medias[medias$Group.2 == 9,][3]),col=9)
}
for(r in 55:60)
{
  lines(c(r,r),c(tamboril.altura[r],medias[medias$Group.2 == 10,][3]),col=10)
}
lines(c(1,6),c(medias[medias$Group.2 == 1,][3],medias[medias$Group.2 == 1,][3]),col=1)
lines(c(7,12),c(medias[medias$Group.2 == 2,][3],medias[medias$Group.2 == 2,][3]),col=2)
lines(c(13,18),c(medias[medias$Group.2 == 3,][3],medias[medias$Group.2 == 3,][3]),col=3)
lines(c(19,24),c(medias[medias$Group.2 == 4,][3],medias[medias$Group.2 == 4,][3]),col=4)
lines(c(25,30),c(medias[medias$Group.2 == 5,][3],medias[medias$Group.2 == 5,][3]),col=5)
lines(c(31,36),c(medias[medias$Group.2 == 6,][3],medias[medias$Group.2 == 6,][3]),col=6)
lines(c(37,42),c(medias[medias$Group.2 == 7,][3],medias[medias$Group.2 == 7,][3]),col=7)
lines(c(43,48),c(medias[medias$Group.2 == 8,][3],medias[medias$Group.2 == 8,][3]),col=8)
lines(c(49,54),c(medias[medias$Group.2 == 9,][3],medias[medias$Group.2 == 9,][3]),col=9)
lines(c(55,60),c(medias[medias$Group.2 == 10,][3],medias[medias$Group.2 == 10,][3]),col=9)



medias<- aggregate(tamboril$altura, by=list(tamboril$especie, tamboril$substrato),FUN= mean)
str(medias)
media.substrato<-medias$x
medias[medias$Group.2 == 1,]


#2. Vamos fazer os clculos da ANOVA na unha:

# Separe apenas os dados referentes  espcie "tamboril" em um objeto chamado tamboril

tamboril<- mudas[mudas$especie == "tamboril",]

#Calcule a mdia de todas as alturas de tamboril
media.g<-mean(tamboril[,4])
media.g
#Crie um objeto chamado ss.total com a somatria do desvio quadrtico total dos dados.

ss.total <- sum((tamboril[,4] - media.g)^2) 
ss.total



#Calcule a mdia de alturas para cada substrato


m.substrato <- aggregate (tamboril$altura, by=list(tamboril$substrato), FUN= mean, na.rm=TRUE)
m.substrato

#Crie um objeto chamado ss.intra com a somatria do desvio quadrtico intra-grupos (dica: a funo rep() pode ser sua amiga)


difer.med<- m.substrato$x - med.g
difer.med
str(difer.med)
ss.1<- sum((difer.med[1])^2)
ss.1
ss.2<- sum((difer.med[2])^2) 
ss.2
ss.3<- sum((difer.med[3])^2)
ss.3
ss.4<- sum((difer.med[4])^2)
ss.4
ss.5<- sum((difer.med[5])^2)
ss.5
ss.6<- sum((difer.med[6])^2)
ss.6
ss.7<- sum((difer.med[7])^2)
ss.7
ss.8<- sum((difer.med[8])^2)
ss.8
ss.9<- sum((difer.med[9])^2)
ss.9
ss.10<-sum((difer.med[10])^2)
ss.10

ss.intra<- ss.1+ss.2+ss.3+ss.4+ss.5+ss.6+ss.7+ss.8+ss.9+ss.10
ss.intra


#Crie um objeto chamado ss.entre com a somatria do desvio quadrtico entre grupos (lembre de levar em conta as diferentes rplicas)

ss.entre <- 6*sum((media.substrato$x - media.g)^2)
ss.entre
# ss.intra numero de amostras (60)  - 10 observaes (mdias) = 57
ss.intra/50
# ss.entre (numero de grupos (9) menos uma observao (mdia) = 2
ss.entre/9
# razo entre as somas dos quadraticos intra e entre
razao<- ss.entre/ss.intra
razao
prob<- pf(razao,9,50, lower.tail=FALSE)
prob
porc<- prob*100
porc

