### Exercicio 7 #####

# 7.2 O modelo mais simples possvel

#Vamos retomar a regresso da massa do crebro em funo da massa corporal de alguns animais, do tutorial ajuste e diagnstico de uma regresso:

anim.m2 <- lm(log(brain)~log(body),data=Animals, 
              subset=!(log(Animals$body)>8&log(Animals$brain)<6))
#Agora ajuste este modelo:

anim.m0 <- lm(log(brain)~1, data=Animals, 
              subset=!(log(Animals$body)>8&log(Animals$brain)<6))
#E compare os dois:

anova(anim.m0,anim.m2)
#1. Qual a relao do comando 'anova' acima com:   anova(anim.m2)

# R. O comando acima retorna a comparao entre os dois modelos, sendo um o modelo nulo - onde crecimento do eixo y  igual a x, exibindo o valor estimativa "F".   

#2. Qual a relao entre os valores obtidos por estes comandos:
summary(anim.m0)
mean(log(Animals$brain[!(log(Animals$body)>8&log(Animals$brain)<6)]))
sd(log(Animals$brain[!(log(Animals$body)>8&log(Animals$brain)<6)]))

# R. As funces "mean" e "sd" retornam os valores da mdia do intercepto e do erro padro dos rediduos, respectivamente. Ambos descritos pela funco "summary".

#Dica
#Um comando mais curto para ajustar o modelo deste exerccio, e que ajuda a interpret-lo:

anim.m0 <- update(anim.m2, .~. -log(body))

#107.3 Resduos de Iris
iris
iris$Species[iris$Species=="setosa"]
iris.setosa<- iris[iris$Species=="setosa",]
iris.setosa
#Crie um objeto chamado lm.iris que contenha uma regresso linear da largura da spala em funo do comprimento da spala.

lm.iris<- lm(iris.setosa$Sepal.Width~iris.setosa$Sepal.Length)
lm.iris
#Crie um objeto chamado lm.iris.coef que contenha os coeficientes dessa regresso (intercepto e inclinao). Dica: Existe uma funo especfica para extrair coeficientes de modelos ajustados.

lm.iris.coef <-coef(lm.iris)
lm.iris.coef
#Crie um objeto chamado lm.iris.nopetal que contenha a mesma regresso, mas descontando do efeito do comprimento da ptala de cada varivel. Crie tambm um objeto contendo os coeficientes (intercepto e inclinao) desse novo modelo, chamado lm.iris.nopetal.coef.




largura<- lm(iris.setosa$Sepal.Width~iris.setosa$Petal.Length)
largura
comprimento<- lm(iris.setosa$Sepal.Length~iris.setosa$Petal.Length)
comprimento

residuos.largura<-residuals(largura)
residuos.largura

residuos.comprimento<- residuals(comprimento)


lm.iris.nopetal<- lm(residuos.largura~residuos.comprimento)
lm.iris.nopetal
summary(lm.iris.nopetal)



lm.iris.nopetal.coef<- coef(lm.iris.nopetal)
lm.iris.nopetal.coef

summary(lm.iris)
summary(lm.iris.nopetal)


### 107.4 Presso e temperatura
#Vamos usar um conjunto de dados do R chamado pressure, que contm dados da presso de vapor de mercrio em funo da temperatura. Carregue esse conjunto de dados na sua rea de trabalho, e salve as colunas pressure e temperature em dois objetos novos, p e t, para facilitar os prximos passos.

pressure

p<- pressure[,2]
p
t<- pressure[,1]
t
#plot(p~t)

# A relao entre elas parece ser linear?

# R. No.A variavel resosta  constante at o limiar 200 da variavel preditora.

#Mas vamos fazer uma regresso linear mesmo assim! Crie um objeto chamado reg1 contendo a regresso linear de p em funo de t.
reg1 <- lm(p~t)

#plot(reg1)


#Visualize como essa regresso se comporta. D pra fazer melhor, no ? Crie um objeto chamado reg2 contendo a regresso de p em funo de t e t (lembre-se do tutorial!).

reg2<- update(reg1,.~. +I(t^2))

#plot(reg2)



reg3<- update(reg2, .~. + I(t^3))
plot(reg3)

#Ser que uma regresso com ordem maior sempre vai ajustar melhor um conjunto de dados? Ser que uma regresso com ordem maior sempre vai ser melhor do que uma regresso linear?

summary(reg1)
summary(reg2)
summary(reg3)


str(reg3) 
names(summary(reg3))

r2 <-summary(reg3)$r.squared 

#107.5 Seriemas e Carcars
#Vamos utilizar o conjunto de dados Aves no Cerrado para avaliar se o nmero de avistamentos de seriemas  afetado pelo nmero de Carcars avistados, em cada fisionomia de cerrado. Estamos interessados em responder as seguintes perguntas:

aves<-read.table("aves_cerrado.csv", header=T, sep = ";", as.is = T)
aves

aves$seriema[is.na(aves$seriema)]<-0
aves$carcara[is.na(aves$carcara)]<-0
aves$urubu[is.na(aves$urubu)]   <- 0 

aves$fisionomia[aves$fisionomia=="ce"] <- "Ce"
aves$fisionomia <- factor(aves$fisionomia, levels=c("CL","CC","Ce"))

dados.ce<- aves[aves$fisionomia == "Ce",] 
dados.cc<- aves[aves$fisionomia== "CC",]
dados.cl<- aves[aves$fisionomia == "CL",] 
mod.ce<-lm(seriema~carcara, data=dados.ce)
anova(mod.ce)


mod.cc<-lm(seriema ~ carcara, data= dados.cc)
anova(mod.cc)

mod.cl<-lm(seriema ~ carcara, data= dados.cl)
anova(mod.cl)

p.ce<- anova(mod.ce)$"Pr(>F)"[1]
p.cc<- anova(mod.cc)$"Pr(>F)"[1]
p.cl<- anova(mod.cl)$"Pr(>F)"[1]

coef.cc <-coef(mod.cc)
coef.ce<- coef(mod.ce)
coef.cl<- coef(mod.cl)




#1. H relao entre o nmero de avistamentos de seriemas e carcars em alguma das fisionomias amostradas?

# R. Aparentemente, os avistamentos das Seriemas tem um relao inversa aos avistamentos dos Carcaras. Etretanto, apenas o modelo de fisonomia "CL" apresentou grau de significncia estatstica.  

#H diferenas na relao entre o nmero de avistamentos de seriemas e carcars entre as fisionomias do Cerrado?

# R. A fisionomia "ce" exibiu maior nmero de avistamentos de Carcars, na comparao aos demais.   

########## Exercicio 7b ###########

#Antes de passarmos para os exerccios de regresses mltiplas, vamos revisar a regresso simples mais uma vez. Uma forma de avaliar a incerteza na previso de um modelo de regresso  fazer um grfico com o intervalo de confiana de 95% da previso do modelo. Para isso  preciso estimar esse intervalo da previso e plotar um grfico com os dados, o modelo e as curvas do intervalo de confiana. Para estimar o intervalo de confiana  preciso calcular o erro padro da previso do modelo e multiplicar pelo valor t de Student, para n-2 graus de liberdade. O erro padro no  constante para todos os valores previstos, pode variar de acordo com o valor da varivel preditora de acordo com a frmula:

#Construa esse grfico para avaliar a incerteza do modelo para a relao peso do beb (kg) ~ tempo de gestao (dias) dos dados Massa ao Nascer e Dados da me, usando a frmula acima para estimar o intervalo de confiana de 95%.

setwd("C:/Curso R/Curso R 2019/Aula 7")

babies<- read.table("babies.txt", header=TRUE, sep=";", as.is = TRUE)
babies$gestation[babies$gestatio == 999]<- NA

# funo omite os valores "NAs"
na.omit(babies$gestation)

plot(bwt ~ gestation, data=babies)

babes.mod1<- lm(bwt~gestation, data=babies)

# vetor com 100 numeros a partir da variavel preditora "tempo de gestao" 
t.gest<- seq(min(babies$gestation, na.rm = TRUE), max(babies$gestation, na.rm = TRUE ), length.out=100)


summary(babes.mod1)

# Argumentos para a formula do sey!

SSX<- sum(t.gest- mean(t.gest)^2)
SSX
var.y<- var(babies$bwt)
var.y
n<- length(babies$bwt)

# formula variancia sum((babies$bwt-mean(babies$bwt))^2)/ (length(babies$bwt)-1)
x<- t.gest
x
# recebe a mdia do vetor criado com a sequencia de 100 valores a partir do tempo de gestao
x.med<- mean(t.gest)
x.med

#Formula com os argumentos acima mais o p valor de 95% "qt(0.025, 1, lower.tail = TRUE)"

sey<- sqrt(var.y* 1/n + (x-x.med)^2/SSX) * qt(0.025, 1, lower.tail = TRUE)

x11()

plot(bwt ~ gestation, data=babies, ylab= "Peso (g)", xlab="Tempo de gestao")
abline(babes.mod1, col="red")

# Formula ======> y=a+b*x+rnorm(0,mdia),
#sendo: (a= sey, b=inclinao, x= vetor com os 100 num) + distribuio normal com o comprimento da variavel preditora, mdia 0 e o valor do residual standard Error.
# valores extraidos a partir do summary do modelo.

gest.prev<- sey + (0.46426*t.gest) + rnorm(100,0, 16.66)

# novo modelo utilizando o objeto construido a partir da formula sey.
mod.2<- lm(gest.prev~t.gest)
abline(mod.2)

# linhas com os valores inferiores do desvio padro.
lines(gest.prev - qt(0.025, 1, lower.tail = TRUE) ~ t.gest, col="blue")

# linhas com os valores superiores do desvio padro.
lines(gest.prev + qt(0.025, 1, lower.tail = TRUE) ~ t.gest, col="green")

# poligono utilizando os limites dos intervalos de confiana.
polygon(c(rev(t.gest), t.gest), c(rev(gest.prev - qt(0.025, 1, lower.tail = TRUE)), gest.prev + qt(0.025, 1, lower.tail = TRUE)),
        col = rgb(0,0,0,0.2), border = NA)

savePlot("Intervalos de confiana.png", type= "png")

#Galileu estava Certo?
#Partindo do tutorial Ajuste de Polinmios, avalie se um polinmio de terceiro grau  um melhor modelo para descrever os dados do experimento de Galileu. A equao para este modelo :

init.h = c(600, 700, 800, 950, 1100, 1300, 1500)
h.d = c(253, 337, 395, 451, 495, 534, 573)  
plot(h.d~init.h)
mod1 <- lm(h.d~init.h)
mod2 <- update(mod1,.~. +I(init.h^2))
mod3<- mod2 <- update(mod2,.~. +I(init.h^3))

anova(mod1, mod3)

# R. sim, o modelo de terceiro grau  melhor, pois ele explica cerca de 175 vezes mais que o modelo 1, restando apenas 48 residuos em comparao ao primeiro. 

#Massa de Recm-Nascidos


#Utilize todas as variveis disponveis no conjunto de dados Massa ao Nascer e Dados da me para chegar ao melhor modelo de previso da massa de bebs ao nascer.

babies$gestation[babies$gestation == 999]
na.omit(babies$gestation[babies$gestation == 999])
babies$parity[babies$parity == 9]
babies$age[babies$age == 99] <- NA
na.omit(babies$age[babies$age == 99])
babies$height[babies$height == 99] <- NA
na.omit(babies$height[babies$height == 99])
babies$weight[babies$weight == 999]<- NA
na.omit(babies$weight[babies$weight == 999])
babies$smoke[babies$smoke == 9]<-NA
na.omit(babies$smoke[babies$smoke == 9])


peso00<-lm(babies$bwt~1)
anova(peso00)

peso01<- lm(babies$bwt~babies$gestation+babies$parity+babies$age+ babies$height+babies$weight+babies$smoke)

anova(peso01)
peso02<- lm(babies$bwt~babies$gestation+babies$parity+babies$height+babies$weight+babies$smoke)
anova(peso02)

peso03<- lm(babies$bwt~babies$gestation+ babies$smoke)
anova(peso03)


# o modelo mais simples que explica a maior parte das variaes dos dados  o "peso03".

