#### Exerccios 4 - Anlises Exploratrias


#### 4.1 Rios

#carrega um objeto na area de trabalho
data(rivers)
m.rios<- mean(rivers)
prop.mm <- length(rivers[rivers<m.rios])/length(rivers)

quantil.75<- quantile(rivers, 0.75)
Quantis<-quantile(rivers, c(0.25, 0.5))
medias<- c(mean(rivers),mean(rivers,trim=0.25),median(rivers)) 
summary(rivers)

# 4.2 Cervejas
cervejas <-c("chope","lata","garrafa","chope","garrafa", "garrafa","lata","lata","nenhuma","lata","garrafa","garrafa", "garrafa","lata","lata","lata","garrafa","lata","chope","nenhuma", "garrafa","garrafa","garrafa","chope","garrafa","garrafa","chope","garrafa","lata","lata")
cervejas<- as.factor(cervejas)
#1.Represente este resultado como um grfico de barras e um dotplot (funo dotchart).
plot(cervejas)
preferencia<-table(cervejas)
dotchart(preferencia)

# 2.Qual tem maior razo dado/tinta?
# R. O grafico mais eficiente em apresentar os dados  o dotchart.


# 4.3 Caixetais

caixeta<- read.table("caixeta.csv", header = T, sep=",", as.is=F)

table(caixeta$fuste)

# 1.Construa um histograma do dap1) dos fustes dos caixetais
hist(table(caixeta$cap)/pi)

# 2. Construa histogramas da altura das rvores para os diferentes caixetais ('local')

caixeta.jureia<- caixeta[caixeta$local =="jureia",]
hist(table(caixeta.jureia$h, caixeta.jureia$local))

caixeta.chauas<- caixeta[caixeta$local =="chauas",]
hist(table(caixeta.chauas$h, caixeta.chauas$local))

caixeta.retiro<- caixeta[caixeta$local =="retiro",]
hist(table(caixeta.retiro$h, caixeta.retiro$local))

# 3. H diferenas entre as estruturas (distribuio de tamanhos) dos caixetais?
# R. Existe variao, porm no muito significativas


# 4.4

egrandis<- read.table("egrandis.csv", header = T, sep = ";", as.is=F)

# 1. Utilize o grfico boxplot para analisar o DAP de rvores de E. grandis em funo das variveis regio (regiao) e rotao (rotacao).
boxplot(egrandis$dap ~egrandis $regiao+egrandis$rotacao)

# 2. Avalie a normalidade da altura do conjunto total de rvores com um grfico quantil-quantil contra a distribuio normal
qqnorm(egrandis$dap ~egrandis $regiao+egrandis$rotacao)

#4.5 

#1. Analise a relao dap-altura ('dap' e 'h') em funo do caixetal (local) com a funo plot, mas somente para as rvores 2) de caixeta (Tabebuia cassinoides).
caixeta
caixeta$dap <- (pi/4)* (caixeta$cap/10)
caixeta$area.basal<-  (((caixeta$dap)^2)*pi)/4 
caixeta.Tabebuia = caixeta[caixeta$especie == "Tabebuia cassinoides",]

soma.fustes = aggregate (caixeta.Tabebuia$area.basal, by=list( caixeta.Tabebuia$fuste, caixeta.Tabebuia$arvore,  caixeta.Tabebuia$local, caixeta.Tabebuia$h), FUN=sum) 
soma.fustes 

fustes.total= aggregate(soma.fustes$x, by=list(soma.fustes$Group.2, soma.fustes$Group.3, soma.fustes$Group.4), FUN=sum) 
fustes.total 

fustes.total$dap.total = sqrt((4*fustes.total$x)/pi) 
names(fustes.total) = c("arvore", "local", "altura", "area.basal", "dap.total") 
fustes.total 
plot(fustes.total$dap.total ~ fustes.total$local + fustes.total$altura, data=fustes.total)

# 2. Para a mesma relao do item anterior, verifique linearidade com a funo scatter.smooth
scatter.smooth (fustes.total$dap.total ~ fustes.total$local + fustes.total$altura, data=fustes.total)


# 3.Utilizando o pacote lattice, analise a relao dap-altura ('dap' e 'h') em funo do caixetal (local), mas somente para as rvores 3) de caixeta (Tabebuia cassinoides).

caixeta.2 = caixeta[caixeta$especie == "Tabebuia cassinoides",]

soma.fustes.2 = aggregate (caixeta.2$area.basal, by=list(caixeta.2$fuste, caixeta.2$arvore,  caixeta.2$local, caixeta.2$h), FUN=sum) 
soma.fustes.2 

fustes.total.2= aggregate(soma.fustes.2$x, by=list(soma.fustes.2$Group.2, soma.fustes.2$Group.3, soma.fustes.2$Group.4), FUN=sum) 
fustes.total.2 

fustes.total.2$dap.total.2 = sqrt((4*fustes.total.2$x)/pi) 
names(fustes.total.2) = c("arvore", "local", "altura", "area.basal", "dap.total") 
fustes.total.2 

library(lattice)

dotplot(fustes.total.2$dap.total ~ fustes.total.2$local + fustes.total.2$altura, data=fustes.total.2)

save.image("Exercicio2_tabela.Rdata")
